using System;
using System.Collections.Generic;
using System.Text;

namespace igeterm
{
	class encodeClass
	{
		private byte[] old = new byte[3];

		public void ClearBuffer()
		{
			old[0] = old[1] = old[2] = 0;
		}

		public string GetStringSJIS(byte[] data, int index, int count)
		{
			byte[] buf = new byte[count + 1];
			int pos = 0;
			string str = "";

			for (int n = 0; n < count; n++)
			{
				if (old[0] == 0)
				{
					if ((data[n] >= 0x81 && data[n] <= 0x9f) || (data[n] >= 0xe0 && data[n] <= 0xef))
					{
						old[0] = data[n];
					}
					else
					{
						buf[pos++] = data[n];
					}
				}
				else
				{
					buf[pos++] = old[0];
					buf[pos++] = data[n];
					old[0] = 0;
				}
			}
			str = System.Text.Encoding.GetEncoding("shift_jis").GetString(buf, 0, pos);

			return (str);
		}

		public string GetStringUTF8(byte[] data, int index, int count)
		{
			byte[] buf = new byte[count + 2];
			int pos = 0;
			string str = "";

			for (int n = 0; n < count; n++)
			{
				if ((data[n] & 0x80) == 0x80)					//utf-8}`oCgH
				{
					if ((data[n] & 0x40) == 0x40)
					{
						old[0] = data[n];
					}
					else if (old[1] == 0)
					{
						old[1] = data[n];
						if ((old[0] & 0xe0) == 0xc0)
						{
							buf[pos++] = old[0];
							buf[pos++] = old[1];
							old[0] = old[1] = old[2] = 0;
						}
					}
					else if (old[2] == 0)
					{
						old[2] = data[n];
						if ((old[0] & 0xf0) == 0xe0)
						{
							buf[pos++] = old[0];
							buf[pos++] = old[1];
							buf[pos++] = old[2];
							old[0] = old[1] = old[2] = 0;
						}
						else
						{
							old[0] = old[1] = old[2] = 0;
						}
					}
				}
				else
				{
					buf[pos++] = data[n];
				}
			}
			str = System.Text.Encoding.UTF8.GetString(buf, 0, pos);
			return (str);
		}

		public string GetStringBig5(byte[] data, int index, int count)
		{
			byte[] buf = new byte[count + 1];
			int pos = 0;
			string str = "";

			for (int n = 0; n < count; n++)
			{
				if (old[0] == 0)
				{
					if ((data[n] >= 0xa1 && data[n] <= 0xc6) || (data[n] >= 0xc9 && data[n] <= 0xf9))
					{
						old[0] = data[n];
					}
					else
					{
						buf[pos++] = data[n];
					}
				}
				else
				{
					buf[pos++] = old[0];
					buf[pos++] = data[n];
					old[0] = 0;
				}
			}
			str = System.Text.Encoding.GetEncoding("shift_jis").GetString(buf, 0, pos);

			return (str);
		}

	}
}
